(in-package :custom)
(use-package :oli)

(sd-defdialog 'Kehlnaht-einfach
	:dialog-title "Kehlnaht-einfach"
	:toolbox-button t
	:dialog-control :sequential
	:variables '(
		(Startpunkt :value-type :docupntcnp)
		(Zielpunkt :value-type :docupntcnp)
		(aMass :value-type :number :title "a-Mass" :after-input (Kehlnaht-einfach))	
		);variables

;;    :ok-action '(Kehlnaht-einfach)
    :local-functions '(
    
		(Kehlnaht-einfach ()
		
		(if (not (equal Startpunkt Zielpunkt))
			(progn
									
				(defun rahmen ()
		  			(let 
		  				((sht-struct (oli:sd-am-inq-sheet (oli:sd-am-inq-curr-sheet))))
		    			(oli:sd-am-inq-name (sd-am-sheet-struct-frame sht-struct))
		    		);let
	    		);defun
	    		
				(setf ansicht 
					(sd-call-cmds 
						(get_selection 	:focus_type *sd-anno-view-seltype*
                                     	:select Startpunkt
						);get_selection
					);sd-call-cmds
				);setf
								
				(when (not ansicht)
					(setf ansicht 
						(sd-call-cmds 
							(get_selection 	:focus_type *sd-anno-flat-seltype*
											:select Startpunkt
							);get_selection
						);sd-call-cmds
					);setf
				);when

				(if ansicht
					(oli::sd-am-set-default-owner :symbol :2dview (first ansicht))
					(oli::sd-am-set-default-owner :symbol :2dview :current-sheet)  ;; Besitzer ist aktuelles Blatt
				);if
				
				(progn 
				
					(setf sp (make-gpnt2d :x (gpntdocu_x Startpunkt)
                                      :y (gpntdocu_y Startpunkt)));setf
					(setf zp (make-gpnt2d :x (gpntdocu_x Zielpunkt)
                                      :y (gpntdocu_y Zielpunkt)));setf
                                                     
					(setf vektor1 (sd-vec-subtract zp sp))
					(setf winkel (- (sd-vec-angle-between (make-gpnt2d :x 1.0 :y 0.0) vektor1) 1.5707963267948966))
          	(display (format nil "winkel = ~a" winkel))
					(setf winkel_grad (* winkel (/ 180.0 pi)))
						(display (format nil "winkel n grad= ~a" winkel_grad))
                                
					(cond 
						((or (and (> winkel_grad 0) (<= winkel_grad 90)) (and (> winkel_grad 90) (<= winkel_grad 180)))
							(sd-call-cmds 	
								(AM_CREATE_SYMBOL_WELDING 
									:owner Startpunkt 
									:shape 802 
									:position :TO_RIGHT 
									:g2 310 
									:text_var :t1 (format nil "a~a" aMass) Zielpunkt) 
							);sd-call-cmds
						);or
						((or (and (> winkel_grad 180) (<= winkel_grad 270)) (and (> winkel_grad -90) (<= winkel_grad 0)))
							(sd-call-cmds 	
								(AM_CREATE_SYMBOL_WELDING 
									:owner Startpunkt 
									:shape 802 
									:position :TO_LEFT 
									:g2 310 
									:text_var :t1 (format nil "a~a" aMass) Zielpunkt) 
							);sd-call-cmds
						);or
					);cond
					
					(sd-call-cmds 
						(am_create_refline :ref_arrow_type 1 :SOURCE Zielpunkt Zielpunkt Startpunkt)
					);sd-call-cmds
				);progn
							
				;; sequential-loop funktioniert nicht (??)
				;; daher so

				(frame2::put-buffer "Kehlnaht-einfach") ;; gleich nochmals aufrufen
				
				;;(sd-call-cmds (am_set_catch_parameters :all))
				                             
			);progn
			
			(display "Start- und Zielpunkt muessen unterschiedlich sein. Werte bitte neu setzen.")
			
			);if
			
		);Kehlnaht-einfach		
	) ;local-functions
) ;sd-defdialog
